<isol>

#!/usr/bin/perl -wT

use CGI qw(:standard);

sub print_err
# Gibt eine Fehlermeldung aus und beendet das Skript
{
  @messages = @_;
  print "Content-type: text/html \n\n";
print <<Finito;
<HTML>\n<HEAD>\n<TITLE>Suche im Glimpse-Archiv</TITLE>\n</HEAD>\n
<BODY BGCOLOR="#dddddd" TEXT="#093e79">\n
<CENTER><H2>Suche im Glimpse-Archiv</H2>\n
<hr size=2 shade>\n<FONT SIZE=4>\n
Finito
  print "<BR>\nFehler: $messages[0]\n</CENTER></HTML>\n";
  exit;
} # sub print_err

# Variablen aus Formular uebernehmen
$pattern = param('search');
$index = param('index');
$display_mode = param('list');
$case = param('no_case');
$whole_word = param('word');
$bool_lines = param('lines');
$typos = param('typos');
$filemask = param('mask');

# Suchmuster ($pattern) und Index ($index) checken und auswerten
if (defined $pattern)                   # AND, OR, NOT durch ;,~ ersetzen
{
  ($pattern eq "") and (print_err("Kein Suchmuster angegeben"));
  $pattern =~ s/^[nN][oO][tT] /~/g;     # NOT am Anfang
  $pattern =~ s/ [aA][nN][dD] [nN][oO][tT] /;~/g;
  $pattern =~ s/ [oO][rR] [nN][oO][tT] /,~/g;
  $pattern =~ s/ [nN][oO][tT] /;~/g;    # NOT alleine meint AND NOT
  $pattern =~ s/ [aA][nN][dD] /;/g;
  $pattern =~ s/ [oO][rR] /,/g;
}
else
{
  print_err("Kein Suchmuster angegeben!");
}
if ($pattern =~ /^([\w. -\/;,~*+\[\]#]+)$/) # untainten: harmlose Zeichen?
{
  $pattern = $1;
}
else
{
  print_err("Suchmuster $pattern enth&auml;lt ung&uuml;ltige Zeichen");
}

(defined $index) || (print_err("Kein Index angegeben"));
if ($index =~ /^(\/[-\/\w.~]+)$/)  # absoluter Pfad mit harmlosen Zeichen?
{ 
  $index = $1;
}
else
{
  print_err("Index $index enth&auml;lt ung&uuml;ltige Zeichen");
}

# restliche Optionen-Variablen checken
(defined $display_mode) || (print_err("Kein Anzeige-Modus angegeben"));
if (defined $case)
{
  if ($case eq "yes") { $case = "ignore"; }
  else { $case = "normal"; }
}
else 
{
  $case = "normal";
}
(defined $whole_word) || ($whole_word = "");
(defined $bool_lines) || ($bool_lines = "");
if (($pattern =~ /~/) && ($bool_lines eq "yes"))
{
  print_err("NOT (~) erfordert dateiweise Bool'sche Operatoren");
}
(defined $typos) || (print_err("Anzahl Tippfehler nicht angegeben"));
(defined $filemask) || ($filemask = "");

# Dateimaske ($filemask) checken und als $F auswerten
if ($filemask eq "")
{
  $F = "";
}
else
{
  if ($filemask =~ /^([-\/\w. ]+)$/)    # harmlose Zeichen?
  {
    $filemask = $1;
  }
  else
  {
    print_err("Dateimaske $filemask enth&auml;lt ung&uuml;ltige Zeichen");
  }
  $F = "-F '$filemask'";
}

# $option und $N aus Optionen-Variablen basteln
$option = "-yz";
if ($display_mode eq "files") { $option .= "l"; }
if ($display_mode eq "count") { $option .= "c"; }
if ($case eq "ignore") { $option .= "i"; }
if ($whole_word eq "yes") { $option .= "w"; }
if (!($bool_lines eq "yes")) { $option .= "W"; }
if ($typos =~ /^([0-9]+)$/) { $typos = $1; }
else { print_err("Anzahl Fehler darf nur Zahlen enthalten"); }
if ($typos eq "0") { $N = ""; }
else { $N = "-" . $typos; }

# HTML-Header ausgeben
print "Content-type: text/html \n\n";
print <<Finito;
<HTML><HEAD><TITLE>Suche im Glimpse-Archiv</TITLE></HEAD>
<BODY BGCOLOR="#dddddd" TEXT="#093e79">
<CENTER><H2>Suche im Glimpse-Archiv</H2></CENTER><FONT size=3>
Finito

# Environment loeschen, glimpse-Aufruf basteln, glimpse starten, 
# Output einlesen und an Webserver schicken
foreach $var(keys(%ENV))     # %ENV ist tainted
{
  delete $ENV{$var};
}

$glimpse = "/usr/local/bin/glimpse -H $index $option $N $F '$pattern'";
print "\"$glimpse\" gestartet ...<BR>\n";
print "<hr size=2 shade>\n";
$|=1;                        # Output nach jedem write flushen
open INPUT, "$glimpse | ";   # glimpse als Pipe starten

while (<INPUT>)              # <a href>s auf die Dateinamen klappt nur,
{                            # wenn das Directory mit den Files in Apaches
  chomp;                     # documentroot (s. httpd.conf) verlinkt ist
  if ($display_mode eq "files")    # nur Dateinamen
  {
    print "<a href=\"http://localhost$_\">$_</a><BR>\n";
  }
  else                             # entweder "Name: n" oder "Name: Text"
  {
    @i = split /: /, $_, 2;
    print "<a href=\"http://localhost$i[0]\">$i[0]</a> : $i[1]<BR>\n";
  }
}
print "</FONT></HTML>";
close INPUT;
